if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
	if(!$RTB::RTBR_ServerControl_Hook)
		exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");
	RTB_registerPref("Enable Hijacking","Vehicle Hijacking","$Pref::Hijacking::Enabled","bool","Server_Hijacking",1,0,0);
	RTB_registerPref("Kill Victims","Vehicle Hijacking","$Pref::Hijacking::Kill","bool","Server_Hijacking",1,0,0);
	RTB_registerPref("Hijack All Riders","Vehicle Hijacking","$Pref::Hijacking::JackAll","bool","Server_Hijacking",1,0,0);
}
else
{
	$Pref::Hijacking::Enabled = 1;
	$Pref::Hijacking::Kill = 1;
	$Pref::Hijacking::JackAll = 1;
}

package Hijacking
{
	function Vehicle::onActivate(%this, %obj, %client, %pos, %vec)
	{
		%driver = %this.getMountedObject(0);
		%jacker = %obj;
		%data = %this.getDatablock();

		if(!$Pref::Hijacking::Enabled || !isObject(%driver) || !isObject(%obj) || %obj.state $= "Dead")
		{
			Parent::onActivate(%this, %obj, %client, %pos, %vec);
			return;
		}

		if(%obj.isMounted() || %obj.getClassName() !$= "Player" || %driver.getClassName() !$= "Player")
		{
			Parent::onActivate(%this, %obj, %client, %pos, %vec);
			return;
		}

		%oldPos = %obj.getHackPosition();
 
		%speedA = mFloor(vectorDist(%obj.getVelocity(),"0 0 0")*4);
		%speedB = mFloor(vectorDist(%this.getVelocity(),"0 0 0"));
		%damageA = mFloor(%obj.getDamageLevel());
		%damageB = mFloor(%this.getDamageLevel());
		%health = %this.getDatablock().maxDamage - %damageB;

		%addThis = %speedA + %speedB - %damageA + %damageB;

		if(%addThis < 10)
			%addThis = 10;

		%currAmount = %this.hijackedAmount + %addThis;

		%percent = mFloor(%currAmount / %health * 100);

		%this.hijackedAmount = %currAmount;

		if(%currAmount >= %health)
		{
			%client.centerPrint("<br><br><br><br><br><color:FFFFFF>Hijacking: <color:00FF00>SUCCESS",3);
			%driver.client.centerPrint("<br><br><br><br><br><color:FFFFFF>Hijacking: <color:FF0000>SUCCESS",3);

			for(%i = 0; %i < %data.numMountPoints; %i++)
			{
				%victim = %this.getMountedObject(0);
				if(isObject(%victim) && %victim.getClassName() $= "Player")
				{
					%push = vectorScale(%victim.getEyeVector(),"-10 0 10");
					%velocity = vectorAdd(%this.getVelocity(),%pushBack);
					%victim.dismount();
					%victim.setVelocity(%velocity);

					if($Pref::Hijacking::Kill)
						%victim.damage(%obj, %victim.getPosition(), %victim.getDatablock().maxDamage, $DamageType::Vehicle);
				}

				if(!$Pref::Hijacking::JackAll) break;
			}

			%obj.setTransform(vectorAdd("0 0 10", %oldPos));
	 		%data.onCollision(%this, %obj, 0, 0);
			//%obj.setObjectMount(%this);

			%this.hijackedAmount = 0;

			if(!%obj.isMounted() || %driver.isMounted())
				%obj.setTransform(%oldPos);
		}
		else
		{
			%client.centerPrint("<br><br><br><br><br><color:FFFFFF>Hijacking: <color:00FF00>" @ %percent @ "%",3);
			%driver.client.centerPrint("<br><br><br><br><br><color:FFFF00>Being Hijacked! <color:FFFFFF>(<color:FF0000>" @ %percent @ "%<color:FFFFFF>)",3);
		}

		if(!%this.decaying)
			%this.decaySched = schedule(250, 0, "HijackDecay", %this);

		Parent::onActivate(%this, %obj, %client, %pos, %vec);
	}
};
activatePackage(Hijacking);

function HijackDecay(%this)
{
	if(%this.hijackedAmount > 0)
	{
		%this.decaying = true;
		%this.hijackedAmount -= 1;
		%this.decaySched = schedule(100, 0, "HijackDecay", %this);
	}
	else
		%this.decaying = false;
}